import { ITreeNode } from './models';
import { IDesignerControllerProps, IDesignerControllerPropsMap, IDesignerLocales } from './types';
declare const DESIGNER_REGISTRY: {
    setComponentDesignerProps: (componentName: string, props: IDesignerControllerProps) => void;
    getComponentDesignerProps: (componentName: string) => IDesignerControllerProps;
    registerDesignerProps: (map: IDesignerControllerPropsMap) => void;
    registerDesignerIcons: (map: Record<string, any>) => void;
    getDesignerIcon: (name: string) => any;
    registerSourcesByGroup(group: string, sources: ITreeNode[]): void;
    setDesignerLanguage(lang: string): void;
    getDesignerLanguage(): string;
    getDesignerMessage(token: string): string;
    registerDesignerLocales(locales: IDesignerLocales['messages']): void;
};
export declare const registry: typeof DESIGNER_REGISTRY;
export {};
