"use strict";
var __assign = (this && this.__assign) || function () {
    __assign = Object.assign || function(t) {
        for (var s, i = 1, n = arguments.length; i < n; i++) {
            s = arguments[i];
            for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                t[p] = s[p];
        }
        return t;
    };
    return __assign.apply(this, arguments);
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.registry = void 0;
var shared_1 = require("@designable/shared");
var models_1 = require("./models");
var getBrowserlanguage = function () {
    var _a;
    if (!window.navigator) {
        return 'en';
    }
    return (window.navigator['browserlanguage'] || ((_a = window.navigator) === null || _a === void 0 ? void 0 : _a.language) || 'en');
};
var getISOCode = function (language) {
    var isoCode = DESINGER_LOCALES.language;
    if (DESINGER_LOCALES.messages[language]) {
        return language;
    }
    shared_1.each(DESINGER_LOCALES.messages, function (_, key) {
        if (key.indexOf(language) > -1 || String(language).indexOf(key) > -1) {
            isoCode = key;
            return false;
        }
    });
    return isoCode;
};
var DESINGER_PROPS_MAP = {
    Root: {
        droppable: true,
        cloneable: false,
        deletable: false,
    },
};
var DESINGER_ICONS_MAP = {};
var DESINGER_LOCALES = {
    messages: {},
    language: getBrowserlanguage(),
};
var DESIGNER_REGISTRY = {
    setComponentDesignerProps: function (componentName, props) {
        var originProps = exports.registry.getComponentDesignerProps(componentName);
        DESINGER_PROPS_MAP[componentName] = __assign(__assign({}, originProps), props);
    },
    getComponentDesignerProps: function (componentName) {
        return DESINGER_PROPS_MAP[componentName] || {};
    },
    registerDesignerProps: function (map) {
        shared_1.each(map, function (props, componentName) {
            exports.registry.setComponentDesignerProps(componentName, props);
        });
    },
    registerDesignerIcons: function (map) {
        Object.assign(DESINGER_ICONS_MAP, map);
    },
    getDesignerIcon: function (name) {
        return DESINGER_ICONS_MAP[name];
    },
    registerSourcesByGroup: function (group, sources) {
        models_1.GlobalDragSource.setSourcesByGroup(group, sources);
    },
    setDesignerLanguage: function (lang) {
        DESINGER_LOCALES.language = lang;
    },
    getDesignerLanguage: function () {
        return DESINGER_LOCALES.language;
    },
    getDesignerMessage: function (token) {
        var locale = DESINGER_LOCALES.messages[getISOCode(DESINGER_LOCALES.language)];
        return locale === null || locale === void 0 ? void 0 : locale[token];
    },
    registerDesignerLocales: function (locales) {
        shared_1.each(locales, function (locale, isoCode) {
            DESINGER_LOCALES.messages[isoCode] = __assign(__assign({}, DESINGER_LOCALES.messages[isoCode]), locale);
        });
    },
};
exports.registry = window['__DESIGNER_REGISTRY__'] || DESIGNER_REGISTRY;
